routes/web.php
<?php

use Illuminate\Support\Facades\Route;

$this->settingRole = config("settings.role");

// Route::group([
//     "namespace" => "Home",
//     "as" => "home.",
// ], function () {
//     Route::get("/", ["uses" => "DashboardsController@index"])->name("index");
// });

Route::namespace("Auth")->group(function () {
    Route::get("/", ["uses" => "LoginController@showLoginForm"])->name("home.index");
    Route::get("login", 'LoginController@showLoginForm')->name("login");
    Route::post("login", 'LoginController@login')->name("login");
    Route::post("logout", 'LoginController@logout')->name("logout");
});

Route::middleware(["auth"])->group(function () {
    //Administrator
    Route::group([
        "middleware" => ["role:" . implode("|", $this->settingRole)],
        "namespace" => "Administrator",
        "as" => "administrator.",
        "prefix" => "administrator"
    ], function () {
        Route::get("/", "DashboardsController@index")->name("dashboards");
        Route::resource("dashboards", "DashboardsController")->only(["index"]);

        Route::group([
            "as" => "profile.",
            "prefix" => "profile"
        ], function () {
            Route::get("/", "ProfileController@index")->name("index");
            Route::put("/update", "ProfileController@update")->name("update");
            Route::delete("/destroy", "ProfileController@updatePassword")->name("destroy");
            Route::put("/update-password", "ProfileController@updatePassword")->name("update-password");
            Route::put("/update-avatar", "ProfileController@updateAvatar")->name("update-avatar");
        });

        Route::group([
            "middleware" => ["role:" . $this->settingRole["superadmin"]],
        ], function () {
            Route::resource("roles", "RolesController")->except(["show"]);
            Route::resource("permissions", "PermissionsController")->except(["show"]);
        });

        Route::resource("users", "UsersController")->only(["index", "destroy"]);
        Route::group([
            "as" => "users.",
            "prefix" => "users"
        ], function () {
            Route::put("/{id}/update-password", "UsersController@updatePassword")->name("update-password");
            Route::put("/{id}/update-status", "UsersController@updateStatus")->name("update-status");
            Route::put("/{id}/update-avatar", "UsersController@updateAvatar")->name("update-avatar");

            Route::get("/admin", "UsersController@adminIndex")->name("admin.index");
            Route::get("/admin/create", "UsersController@adminCreate")->name("admin.create");
            Route::post("/admin/create", "UsersController@adminStore")->name("admin.store");
            Route::get("/admin/{id}/edit", "UsersController@adminEdit")->name("admin.edit");
            Route::put("/admin/{id}/edit", "UsersController@adminUpdate")->name("admin.update");

            Route::get("/participant", "UsersController@participantIndex")->name("participant.index");
            Route::get("/participant/create", "UsersController@participantCreate")->name("participant.create");
            Route::post("/participant/create", "UsersController@participantStore")->name("participant.store");
            Route::get("/participant/{id}/edit", "UsersController@participantEdit")->name("participant.edit");
            Route::put("/participant/{id}/edit", "UsersController@participantUpdate")->name("participant.update");
        });

        Route::resource("sessions", "SessionsController");
        Route::resource("types", "TypesController");

        Route::resource("categories", "CategoriesController")->only(["show", "edit", "update", "destroy"]);
        Route::get("categories/{typeId}/create", "CategoriesController@create")->name("categories.create");
        Route::post("types/{typeId}", "CategoriesController@store")->name("categories.store");

        Route::resource("questions", "QuestionsController")->only(["edit", "update", "destroy"]);
        Route::get("questions/{categoryId}/create", "QuestionsController@create")->name("questions.create");
        Route::post("categories/{categoryId}", "QuestionsController@store")->name("questions.store");
        Route::post("questions/upload-image", "QuestionsController@uploadImage")->name("questions.upload-image");

        Route::resource("answers", "AnswersController")->except(["show"]);
    });

    //Participant
    Route::group([
        "middleware" => ["role:Participant"],
        "namespace" => "Participant",
        "as" => "participant.",
        "prefix" => "participant"
    ], function () {
        Route::get("/", "DashboardsController@index")->name("dashboards");
        Route::resource("types", "TypesController");

        Route::group([
            "as" => "profile.",
            "prefix" => "profile"
        ], function () {
            Route::get("/", "ProfileController@index")->name("index");
            Route::put("/update-password", "ProfileController@updatePassword")->name("update-password");
            Route::put("/update-avatar", "ProfileController@updateAvatar")->name("update-avatar");
        });
    });
});

app/Http/Controllers/Administrator/UsersController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use App\Rules\MatchOldPassword;

use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Storage;

use App\User;
use App\Models\Person;
use App\Models\Session;
use App\Models\SessionUser;

class UsersController extends Controller
{
    public function __construct()
    {
        $this->settingRole = config("settings.role");

        $this->middleware(function ($request, $next) {
            $this->authUserId = auth()->user()->id;
            $this->authUserRole = auth()->user()->roles->first()->name;
            return $next($request);
        });
    }

    public function index(Request $request)
    {
        if ($this->authUserRole === $this->settingRole["superadmin"]) {
            $users = User::whereHas(
                "person",
                function ($people) {
                    $people->orderBy("full_name");
                }
            )->get();
        } else {
            $users = User::whereHas(
                "roles",
                function ($roles) {
                    $roles->where("name", "!=", $this->settingRole["superadmin"]);
                }
            )->whereHas(
                "person",
                function ($people) {
                    $people->orderBy("full_name");
                }
            )->get();
        }

        return view(
            "administrator.users.index",
            compact("users")
        )->with('i', ($request->input("page", 1) - 1) * 10);
    }

    public function destroy($id)
    {
        if ($this->authUserId === (int) $id) {
            Auth::logout();
        }
        User::findOrFail($id)->delete();

        return redirect()->back()->with("success", "User deleted successfully.");
    }

    public function adminIndex(Request $request)
    {
        $users = User::whereHas(
            "roles",
            function ($roles) {
                $roles->where("name", $this->settingRole["admin"]);
            }
        )->whereHas(
            "person",
            function ($people) {
                $people->orderBy("full_name");
            }
        )->get();

        return view(
            "administrator.users.admin.index",
            compact("users")
        )->with('i', ($request->input("page", 1) - 1) * 5);
    }

    public function adminCreate()
    {
        return view(
            "administrator.users.admin.create"
        );
    }

    public function adminStore(Request $request)
    {
        $this->validate($request, [
            "name" => "required|string|max:255",
            "email" => "required|email|max:255|unique:users",
            "username" => "required|string|max:255|unique:users",
            "password" => "required|string|min:6|confirmed"
        ]);
        $input = $request->all();

        $input["password"] = Hash::make($input["password"]);
        $user = User::create($input);
        Person::updateOrCreate(
            [
                "user_id" => $user->id,
            ],
            [
                "full_name" => $request->input("name")
            ]
        );
        $role = Role::whereName("Admin")->first();
        $user->assignRole([$role->id]);

        return redirect()->route(
            "administrator.users.admin.index"
        )->with("success", "User created successfully.");
    }

    public function adminEdit($id)
    {
        $user = User::findOrFail($id);

        return view(
            "administrator.users.admin.edit",
            compact("user")
        );
    }

    public function adminUpdate(Request $request, $id)
    {
        $this->validate($request, [
            "name" => "required|string|max:255",
            "email" => "required|email|max:255|unique:users,email," . $id,
            "username" => "required|string|max:255|unique:users,username," . $id
        ]);
        $input = $request->all();

        $user = User::findOrFail($id);
        $user->update($input);
        Person::updateOrCreate(
            [
                "user_id" => $user->id
            ],
            [
                "full_name" => $request->input("name")
            ]
        );

        return redirect()->back()->with("success", "User updated successfully.");
    }

    public function participantIndex(Request $request)
    {
        if ($request->session) {
            $session = Session::find($request->session);
            $users = $session->users;
        } else {
            $users = User::whereHas(
                "roles",
                function ($roles) {
                    $roles->where("name", "participant");
                }
            )->whereHas(
                "person",
                function ($people) {
                    $people->orderBy("full_name");
                }
            )->get();
        }

        return view(
            "administrator.users.participant.index",
            compact("users")
        )->with('i', ($request->input("page", 1) - 1) * 10);
    }

    public function participantCreate()
    {
        $sessions = Session::pluck('name', 'id');
        return view(
            "administrator.users.participant.create",
            compact("sessions")
        );
    }

    public function participantStore(Request $request)
    {
        $this->validate($request, [
            "session" => "required|exists:sessions,id",
            "participant_count" => "required|numeric|min:0|not_in:0"
        ]);

        $session = Session::find($request->session);
        for ($i = 0; $i < $request->participant_count; $i++) {
            do {
                $pool = "0123456789abcdefghijklmnopqrstuvwxyz";
                $length = mt_rand(7, 10);
                $username = strtolower(substr(str_shuffle(str_repeat($pool, 5)), 0, $length));

                $user = User::create([
                    'username' => $username,
                    'password' => Hash::make($username)
                ]);
            } while (!$user);

            Person::updateOrCreate(
                [
                    "user_id" => $user->id,
                ],
                [
                    "full_name" => $user->username
                ]
            );
            $role = Role::whereName("Participant")->first();
            $user->assignRole([$role->id]);

            $user = SessionUser::create([
                'session_id' => $session->id,
                'user_id' => $user->id
            ]);
        }

        return redirect()->route(
            "administrator.users.participant.index"
        )->with("success", "User created successfully.");
    }

    public function participantEdit($id)
    {
        $user = User::findOrFail($id);
        $sessions = Session::pluck('name', 'id');

        return view(
            "administrator.users.participant.edit",
            compact("user", "sessions")
        );
    }

    public function participantUpdate(Request $request, $id)
    {
        $this->validate($request, [
            "session" => "required|exists:sessions,id",
            "username" => "required|string|max:255|unique:users,username," . $id
        ]);

        $user = User::updateOrCreate(
            [
                "id" => $id
            ],
            [
                "username" => strtolower($request->username)
            ]
        );

        Person::updateOrCreate(
            [
                "user_id" => $user->id
            ],
            [
                "full_name" => $user->username
            ]
        );

        SessionUser::updateOrCreate(
            [
                "user_id" => $user->id
            ],
            [
                "session_id" => $request->session
            ]
        );

        return redirect()->back()->with("success", "User updated successfully.");
    }

    public function updatePassword(Request $request, $id)
    {
        $request->validate([
            "current_password" => ["required", new MatchOldPassword],
            "new_password" => "required|same:new_confirm_password",
        ]);
        User::findOrFail($id)->update(["password" => Hash::make($request->new_password)]);

        return redirect()->back()->with("success", "Password successfully updated.");
    }

    public function updateStatus(Request $request, $id)
    {
        User::updateOrCreate(
            [
                "id"        => $id
            ],
            [
                "is_active"    => $request->get("status")
            ]
        );

        if ($this->authUserId === (int) $id && $request->get("status") === "0") {
            Auth::logout();
        }

        return response()->json([
            "status" => true,
            "message" => "Status change successfully."
        ]);
    }

    public function updateAvatar(Request $request, $id)
    {
        $request->validate([
            "avatar"        => "required|mimes:jpg,jpeg,png"
        ]);

        $fileName = date("Y_m_d_His") . "_" . uniqid() . "." . $request->file("avatar")->extension();
        $filePath = $request->file("avatar")->storeAs(
            "storage/images/avatars",
            $fileName,
            "public"
        );

        $person = Person::whereUserId($id)->first();
        if ($filePath) {
            if (!preg_match("/^(\/)?seeds/i", $person->avatar)) {
                Storage::disk("public")->delete($person->avatar);
            }

            Person::updateOrCreate(
                [
                    "user_id"     => $person->user_id
                ],
                [
                    "avatar"    => $filePath
                ]
            );
        }

        return redirect()->back()->with("success", "Avatar successfully updated.");
    }
}

app/Http/Controllers/Participant/DashboardsController.php
<?php

namespace App\Http\Controllers\Participant;

use App\Http\Controllers\Controller;

class DashboardsController extends Controller
{
    public function __construct()
    {
        $this->settingRole = config("settings.role");

        $this->middleware(function ($request, $next) {
            $this->authUserRole = auth()->user()->roles->first()->name;
            return $next($request);
        });
    }

    public function index()
    {
        $userTypes = auth()->user()->sessions->first()->types;
        // dd($userTypes->types());
        return view(
            "participant.dashboards.index",
            compact('userTypes')
        );
    }
}

app/Http/Controllers/Participant/TypesController.php
<?php

namespace App\Http\Controllers\Participant;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Type;

class TypesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $type = Type::findOrFail($id);
        return view(
            "participant.types.show",
            compact('type')
        );
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/administrator/users/participant/create.blade.php
@extends('administrator.layouts.template')

@section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-12">
            <div class="page-title-box">
                <div class="page-title-right">
                    <ol class="breadcrumb m-0">
                        <li class="breadcrumb-item"><a href="{{ route('administrator.users.index') }}">Users</a></li>
                        <li class="breadcrumb-item"><a href="{{ route('administrator.users.participant.index') }}">Peserta</a></li>
                        <li class="breadcrumb-item active">Tambah</li>
                    </ol>
                </div>

                <h4 class="page-title">Tambah Pengguna Peserta</h4>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-sm-12">
            <div class="card">
                <div class="card-body">
                    <form method="POST" action="{{ route('administrator.users.participant.store') }}" class="needs-validation @if(session()->has('errors')) was-validated @endif">
                        @csrf

                        <div class="row">
                            <div class="col-sm-6">
                                <div class="form-group">
                                    <label>Sesi</label>
                                    {!! Form::select('session', $sessions, old('session'), [
                                    'class' => 'form-control' . ($errors->has('session') ? ' is-invalid' : '' ),
                                    'placeholder' => 'Pilih salah satu...',
                                    'required' => 'required'
                                    ]) !!}

                                    @error("session")
                                    <div class="invalid-feedback">{{ $message }}</div>
                                    @enderror
                                </div>
                            </div>

                            <div class="col-sm-6">
                                <div class="form-group">
                                    <label>Jumlah Peserta</label>
                                    <input type="number" name="participant_count" class="form-control @error('participant_count') is-invalid @enderror" placeholder="Jumlah Peserta" value="{{ old('participant_count', 1) }}" required>

                                    @error("participant_count")
                                    <div class="invalid-feedback">{{ $message }}</div>
                                    @enderror
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-sm-12">
                                <button type="submit" class="btn btn-success waves-effect waves-light mt-1 mb-1 mr-2">
                                    <i class="mdi mdi-content-save"></i>
                                    Simpan
                                </button>
                                <a class="btn btn-secondary waves-effect waves-light text-white mt-1 mb-1" href="{{ route('administrator.users.participant.index') }}">
                                    <i class="mdi mdi-reply"></i>
                                    Batal
                                </a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/administrator/users/participant/edit.blade.php
@extends('administrator.layouts.template')

@section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-12">
            <div class="page-title-box">
                <div class="page-title-right">
                    <ol class="breadcrumb m-0">
                        @if (!$user->hasRole($settingRole))
                        <li class="breadcrumb-item"><a href="{{ route('administrator.sessions.index') }}">Sesi Ujian</a></li>
                        <li class="breadcrumb-item"><a href="{{ route('administrator.sessions.edit', $user->sessions->first()->id) }}">{{ $user->sessions()->first()->name }}</a></li>
                        @else
                        <li class="breadcrumb-item"><a href="{{ route('administrator.users.index') }}">Users</a></li>
                        @endif
                        <li class="breadcrumb-item"><a href="{{ route('administrator.users.participant.index') }}">Peserta</a></li>
                        <li class="breadcrumb-item active">Edit</li>
                    </ol>
                </div>

                <h4 class="page-title">Edit Pengguna Peserta</h4>
            </div>
        </div>
    </div>

    @if ($message = session()->get("success"))
    <div class="row">
        <div class="col-12">
            <div class="alert alert-success alert-dismissible fade show" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <i class="mdi mdi-check-all mr-2"></i>
                {{ $message }}
            </div>
        </div>
    </div>
    @endif

    <div class="row">
        <div class="col-sm-12">
            <div class="card">
                <div class="card-body">
                    <h4 class="header-title mb-3">Datail Akun</h4>

                    {{
                        Form::model($user, [
                            "method" => "PUT",
                            "route" => ["administrator.users.participant.update", $user->id]
                        ])
                    }}


                    <div class="row">
                        <div class="col-sm-6">
                            <div class="form-group">
                                <label>Sesi</label>
                                {!! Form::select('session', $sessions, old('session', $user->sessions->first()->id), [
                                'class' => 'form-control' . ($errors->has('session') ? ' is-invalid' : '' ),
                                'placeholder' => 'Pilih salah satu...',
                                'required' => 'required'
                                ]) !!}

                                @error("session")
                                <div class="invalid-feedback">{{ $message }}</div>
                                @enderror
                            </div>
                        </div>

                        <div class="col-sm-6">
                            <div class="form-group">
                                <label>Username</label>
                                <input type="text" name="username" class="form-control @error('username') is-invalid @enderror" placeholder="Username" value="{{ old('username', $user->username) }}" required>

                                @error("username")
                                <div class="invalid-feedback">{{ $message }}</div>
                                @enderror
                            </div>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-12">
                            <button type="submit" class="btn btn-success waves-effect waves-light mt-1 mb-1 mr-2">
                                <i class="mdi mdi-content-save"></i>
                                Simpan
                            </button>
                            <a class="btn btn-secondary waves-effect waves-light text-white mt-1 mb-1 mr-2" href="{{ route('administrator.users.participant.index') }}">
                                <i class="mdi mdi-reply"></i>
                                Batal
                            </a>
                            <button type="button" class="btn btn-danger waves-effect waves-light text-white mt-1 mb-1" onclick="handleDelete()">
                                <i class="mdi mdi-delete"></i>
                                Hapus
                            </button>
                        </div>
                    </div>
                    {{ Form::close() }}

                    {{
                        Form::open([
                            "method" => "DELETE",
                            "route" => ["administrator.users.destroy", $user->id],
                            "id" => "form-delete"
                        ])
                    }}
                    {{ Form::close() }}
                </div>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-sm-4">
            <div class="card">
                <div class="card-body">
                    {{
                        Form::model($user, [
                            "method" => "PUT",
                            "route" => ["administrator.users.update-avatar", $user->id],
                            "files" => true
                        ])
                    }}
                    <div class="row mb-3">
                        <div class="mx-auto">
                            <img class="rounded-circle img-thumbnail" src="{{ asset($user->person->avatar ? $user->person->avatar : '/assets/administrator/images/avatars/default.png') }}" alt="Avatar" width="110">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-12">
                            <div class="form-group">
                                <input type="file" name="avatar" class="form-control-sm form-control-file p-0 @error('avatar') is-invalid @enderror" required>

                                @error("avatar")
                                <div class="invalid-feedback">{{ $message }}</div>
                                @enderror
                            </div>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-12">
                            <button type="submit" class="btn btn-success waves-effect waves-light mt-1 mb-1 mr-2">
                                <i class="mdi mdi-content-save"></i>
                                Simpan
                            </button>
                        </div>
                    </div>
                    {{ Form::close() }}
                </div>
            </div>
        </div>

        <div class="col-sm-8">
            <div class="card">
                <div class="card-body">
                    <h4 class="header-title mb-3">Kata Sandi</h4>

                    {{
                        Form::model($user, [
                            "method" => "PUT",
                            "route" => ["administrator.users.update-password", $user->id],
                            "class" => $errors->has('current_password', 'new_password') ? 'was-validated' : ""
                        ])
                    }}

                    <div class="row">
                        <div class="col-sm-6">
                            <div class="form-group">
                                <label>Kata Sandi Baru</label>
                                <input type="password" name="new_password" class="form-control @error('new_password') is-invalid @enderror" placeholder="Kata Sandi Baru" autocomplete="new-password" required>

                                @error("new_password")
                                <div class="invalid-feedback">{{ $message }}</div>
                                @enderror
                            </div>
                        </div>

                        <div class="col-sm-6">
                            <div class="form-group">
                                <label>Konfirmasi Kata Sandi Baru</label>
                                <input type="password" name="new_confirm_password" class="form-control" placeholder="Konfirmasi Kata Sandi Baru" autocomplete="confirm-password" required>
                            </div>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-12">
                            <button type="submit" class="btn btn-success waves-effect waves-light mt-1 mb-1 mr-2">
                                <i class="mdi mdi-content-save"></i>
                                Simpan
                            </button>
                        </div>
                    </div>
                    {{ Form::close() }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('javascript')
<script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>

<script>
    const handleDelete = () => {
        swal({
                title: "Are you sure?",
                text: "Once deleted, you will not be able to recover this item!",
                icon: "warning",
                buttons: true,
                dangerMode: true,
            })
            .then((willDelete) => {
                if (willDelete) {
                    document.getElementById(`form-delete`).submit();
                }
            });
    }
</script>
@endsection